import spread_rapida as rapida
from .can_packet import CanSend, CanDump


class RapidaSend(CanSend):
    def __init__(self, module_type, module_address, end_frame, **kwargs):
        super(RapidaSend, self).__init__(module_type, module_address, end_frame, cmd=1, **kwargs)

    @property
    def frame(self):
        return ((1 << 7) + self.module_type).to_bytes(1, 'big') + self.end_frame


class RapidaDump(CanDump):
    cmd = 1

    @property
    def command_byte(self):
        return self.frame[1]

    @property
    def data(self):
        return self.frame[2:]

    @property
    def payload(self):
        rs = rapida.responses.of(self.data, self.command_byte)
        if rs.__class__ == rapida.responses.Response:
            cm = rapida.commands.of(self.data, self.command_byte)
            if cm.__class__ != rapida.commands.Command and cm.__class__ != rapida.commands.Query:
                return rapida.payloads.ServicePacket(self, cm)
        return rapida.payloads.ServicePacket(self, rs)
