from spread_core.mqtt.spread.topic import State
from spread_core.mqtt.spread.variable import Variable
from .enginery import Enginery, _EngineryFunit


class _AlarmSensor(Enginery):
    def on_state(self, topic: State, variable: Variable):
        super(_AlarmSensor, self).on_state(topic, variable)

        for subginery in self._subgineries:
            subginery.on_level_changed(self, topic.entity_address.funit_type)


class IntruderSensor(_AlarmSensor):
    pass


class FireSensor(_AlarmSensor):
    pass


class LeakageSensor(_AlarmSensor):
    pass


class _AlarmSensorFunit(_EngineryFunit):
    pass


_AlarmSensor.funit_class = _AlarmSensorFunit


class Guard(_AlarmSensorFunit):
    value_type = bool


class Triggered(_AlarmSensorFunit):
    value_type = bool

    def set(self):
        raise self.NotImplemented()


_AlarmSensor.settable_units = [Guard]

