from spread_core.errors.project_errors import ProjectError
from spread_core.tools import utils
from spread_core.bam import const


def generate_enginery(_id: int, _type: str, data: dict):
    from spread_core.bam.engineries.enginery import Enginery

    # ToDo Иправить этот КОСТЫЛИЩЩЩЕ
    if data.get(const.RECIPE, {}).get(const.TYPE) in ('Rgb', 'Rgbw'):
        _type += 'Complex'

    return _generate(Enginery, _id, _type, data)


def generate_subginery(_id: int, _type: str, data: dict):
    from spread_core.bam.subgineries.subginery import Subginery
    return _generate(Subginery, _id, _type, data)


def generate_provider(_id: int, _type: str, data: dict):
    from spread_core.bam.providers import Provider
    return _generate(Provider, _id, _type, data)


def _generate(super_class: type, _id: int, _type: str, data: dict):

    def separator(subclass): return issubclass(subclass, super_class) and subclass.__name__ == _type
    res = utils.get_subclass(super_class, separator)

    if res:
        try:
            return res(_id, **res.parse_args(**data))
        except Exception as ex:
            raise ProjectError(f'{_type}({_id}): {ex}')

    raise ProjectError(f'Unknown {super_class.__name__} type "{_type}({_id})"')
