import json
import re
from bs4 import BeautifulSoup


if __name__ == '__main__':
    # response = requests.get('https://kiwi.throne.systems/index.php/Bam/Constraints', auth=('Gruzdev', 'password'))
    # soup = BeautifulSoup(response.content, 'html.parser')

    """ Генератор Constraints файлов """

    with open("constraints.htm", encoding="utf-8") as fp:
        soup = BeautifulSoup(fp, 'html.parser')

    table = soup.find("table", class_="standard")
    output = []
    rowspan = {}
    rowcount = 0
    for row in table.tbody.findAll("tr"):
        rowcount += 1
        new_row = []
        new_rowspan = {}
        for column in rowspan:
            if rowspan[column] > 0:
                new_rowspan[column] = rowspan[column] - 1
                new_row.append(column)
        rowspan = new_rowspan

        if len(row.findAll(["td", "th"])) == 1:
            continue

        for cell in row.findAll(["td", "th"]):
            if cell.text == '\n':
                if not cell.a or 'title' not in cell.a.attrs or cell.a.attrs['title'] in (
                        'Bam/Server', 'Bam/Server/Spread', 'Bam/Server/Lite', 'Bam/Manager', 'Bam/Provider'):
                    continue

            if rowcount == 3 and 'colspan' in cell.attrs:
                text = re.match(r'.*/(\w+)$', cell.a.attrs['title']).group(1)
                for i in range(int(cell.attrs['colspan'])):
                    new_row.append(text)
                continue

            if 'rowspan' in cell.attrs:
                if cell.text == '\n' and cell.a:
                    rowspan[re.match(r'.*/(\w+)$', cell.a.attrs['title']).group(1)] = int(cell.attrs['rowspan']) - 1
                else:
                    rowspan[cell.text.strip()] = int(cell.attrs['rowspan']) - 1

            if cell.text == '\n' and cell.a:
                new_row.append(re.match(r'.*/(\w+)$', cell.a.attrs['title']).group(1))
            else:
                new_row.append(cell.text.strip())

        output.append(new_row)

    for row in output:
        print(len(row), row)

    eng_constr = {}
    spread = output[0]
    manager = output[2]
    provider = output[3]
    subg_constr = {}
    # spread[7] = '+'  # Add TeletaskThermoregulator in Spread

    for row in output[4:]:
        if row[0] not in subg_constr:
            subg_constr[row[0]] = []
        if row[1] not in subg_constr[row[0]]:
            subg_constr[row[0]].append(row[1])

        if row[1] not in eng_constr:
            eng_constr[row[1]] = {}
        if row[2] != '-' and row[2] not in eng_constr[row[1]]:
            eng_constr[row[1]][row[2]] = {}
        if row[3] != '-' and row[3] not in eng_constr[row[1]][row[2]]:
            eng_constr[row[1]][row[2]][row[3]] = []

        for i in range(4, len(row)):
            if row[i] == '-':
                continue
            if row[i] == '+' and spread[i] == '+':
                if provider[i] not in eng_constr[row[1]][row[2]][row[3]]:
                    eng_constr[row[1]][row[2]][row[3]].append(provider[i])

    man_prov_constr = {}
    for i in range(4, len(output[0])):
        if spread[i] == '+':
            if manager[i] not in man_prov_constr:
                man_prov_constr[manager[i]] = [provider[i]]
            else:
                man_prov_constr[manager[i]].append(provider[i])

    # with open("eng_constr.json", "w") as file:
    #     json.dump(eng_constr, file, indent=2)
    #
    # with open("man_prov_constr.json", "w") as file:
    #     json.dump(man_prov_constr, file, indent=2)
    #
    # with open("subg_constr.json", "w") as file:
    #     json.dump(subg_constr, file, indent=2)

    with open("constraints.py", "w") as file:
        file.write('ENG_CONSTR = ')
        json.dump(eng_constr, file, indent=4)
        file.write('\n\n')
        file.write('MAN_PROV_CONSTR = ')
        json.dump(man_prov_constr, file, indent=4)
        file.write('\n\n')
        file.write('SUBG_CONSTR = ')
        json.dump(subg_constr, file, indent=4)
        file.write('\n')

    print('Subgineries:', subg_constr)

    for i in man_prov_constr:
        print(f'{i}: {man_prov_constr[i]}')
