from collections import deque

from spread_core.bam.equipment import Equipment
from spread_core.bam.recipe import Recipe


class TestEquipmentAdapter(Equipment):
    def __init__(self):
        super(TestEquipmentAdapter, self).__init__(1, None)
        self.queue = deque()

    def publish(self, topic, variable, retain=False, delay=0, **kwargs):
        self.queue.append((topic, variable, retain, delay))

    def reset_queue(self):
        self.queue = deque()


class TestEngineryRecipe(Recipe):
    def __init__(self, _id=1):
        super(TestEngineryRecipe, self).__init__(1, 'Manager', 2, 'Provider', _id)

    def get_address(self, funit):
        return f'Provider/{self.id}/{funit}'
