from spread_core.warehouse.hardware_warehouse import HardwareWarehouse


class WarehouseInterface:
    def __init__(self):
        self.warehouse = HardwareWarehouse()

    def sorted_info(self):
        yield from self.warehouse.sorted_info()

    def get_provider(self, provider_id):
        return self.warehouse.get_provider(provider_id)

    def add_provider(self, provider):
        provider.set_manager(self)
        self.warehouse.add_provider(provider)
        self.add_binding(provider)

    def add_binding(self, provider):
        self.warehouse.add_binding(provider.binding, provider)

    def providers_by_address(self, short_address):
        yield from self.warehouse.providers_by_address(short_address)

    def get_all_devices(self):
        yield from self.warehouse.all()
