from unittest import TestCase

from spread_dali.address import Short, Group


class TestDaliBindings(TestCase):
    def test_address_short(self):
        for address_index in range(64):
            with self.subTest(short_address=address_index):
                short_address = Short(address_index)
                self.assertEqual(short_address.address, address_index)

    def test_address_short_negative(self):
        for address_index in '0', -1, 64:
            with self.subTest(short_address=address_index):
                with self.assertRaises(ValueError):
                    Short(address_index)

    def test_address_group(self):
        for group_index in '0', -1, 32:
            with self.subTest(group=group_index):
                with self.assertRaises(ValueError):
                    Group(group_index)

    def test_address_group_negative(self):
        for group_index in range(32):
            with self.subTest(group=group_index):
                group = Group(group_index)
                self.assertEqual(group.group, group_index)
