from django.urls import path
from spread_dashboard.commissioning import views
from spread_dashboard.commissioning import views_editor as editor
from spread_dashboard.commissioning import views_print as printer

urlpatterns = [
    path(f'admin/<int:location_id>/<int:area_id>/', editor.of_area, name='edit_area'),
    path(f'admin/<int:location_id>/', editor.of_location, name='edit_location'),
    path(f'admin', editor.index, name='edit_index'),
    path(f'<int:location_id>/<int:area_id>/', views.CommissioningArea.as_view(), name='area'),
    path(f'<int:location_id>/', views.CommissioningLocation.as_view(), name='location'),
    path(f'intro', views.Intro.as_view(), name='intro'),
    path(f'glossary', views.Glossary.as_view(), name='glossary'),
    path(f'', views.CommissioningIndex.as_view(), name='index'),
    path(f'print', printer.for_print, name='print'),
]
