from django.core.management.base import BaseCommand


class Command(BaseCommand):
    help = 'Updates database from local files'

    def add_arguments(self, parser):
        parser.add_argument('--all', action='store_true', help='Does need fill all data')
        parser.add_argument('-c', '--ctp', action='store_true', help='Does need fill a project data')
        parser.add_argument('-t', '--tasks', action='store_true', help='Does need fill a scheduler dump')
        parser.add_argument('-cal', '--calendar', action='store_true', help='Does need fill a calendar dump')
        parser.add_argument('-lf', '--lightfactors', action='store_true', help='Does need fill a light factor dump')
        parser.add_argument('-cs', '--strategies', action='store_true', help='Does need fill a commissioning strategies dump')

    def handle(self, *args, **options):
        if options.get('ctp') or options.get('all'):
            from spread_dashboard.project.bam import Project
            try:
                Project.read_ctp()
            except BaseException:
                print('error ctp filling')
            else:
                print('ctp filling success')

        if options.get('calendar') or options.get('all'):
            from spread_dashboard.scheduler.models import Holiday
            try:
                Holiday.fill()
            except BaseException:
                print('error calendar filling')
            else:
                print('calendar filling success')

        if options.get('tasks') or options.get('all'):
            from spread_dashboard.scheduler.models import SchBase
            try:
                SchBase.fill()
            except BaseException:
                print('error tasks filling')
            else:
                print('tasks filling success')

        if options.get('lightfactors') or options.get('all'):
            from spread_dashboard.scheduler.models import LightFactor
            try:
                LightFactor.fill()
            except BaseException:
                print('error light factors filling')
            else:
                print('light factors filling success')

        if options.get('strategies') or options.get('all'):
            from spread_dashboard.scheduler.models import CommissioningStrategy
            try:
                CommissioningStrategy.fill()
            except BaseException:
                print('error commissioning strategies filling')
            else:
                print('commissioning strategies filling success')
