# Generated manually with Django 3.0.10 on 2022-11-18 18:37
import sys

import django.db.models.deletion
from django.db import migrations, models


def modify_subginery_topics_in_scheduler_actions(*_):
    import os
    from spread_dashboard.project.models import Subginery
    from spread_dashboard.scheduler.models import SchLocation

    for sch_l in SchLocation.objects.all():
        s_id = sch_l.id
        try:
            subginery = Subginery.objects.get(id=s_id)

            triggers = sch_l.schtrigger_set.all()
            sch_l.pk = subginery.locationID
            sch_l.save(timed=False)

            for sch_trigger in triggers:
                sch_trigger.location_id = sch_l.id
                sch_trigger.save(timed=False)

                for sch_action in sch_trigger.schaction_set.all():
                    try:
                        sch_action.topic = sch_action.topic.replace(f'Location/{s_id}', f'Location/{subginery.locationID}')
                        sch_action.save(timed=False)
                    except Exception as ex:
                        print(ex)
            try:
                SchLocation.objects.get(id=s_id).delete(timed=False)
            except SchLocation.DoesNotExist:
                print('Can`t remove SchLocation(%s)' % s_id)
            except Exception as ex:
                print(ex)
        except Subginery.DoesNotExist:
            continue

    if 'test' not in sys.argv:
        os.system(f'sudo supervisorctl restart spread_scheduler')


class Migration(migrations.Migration):

    dependencies = [
        ('spread_dashboard', '0026_eventssqlite'),
    ]

    operations = [
        migrations.AlterField(
            model_name='schtrigger',
            name='location',
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, serialize=False,
                                    to='spread_dashboard.SchLocation'),
        ),
        migrations.RunPython(modify_subginery_topics_in_scheduler_actions),
        migrations.AlterField(
            model_name='schtrigger',
            name='location',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, serialize=False,
                                    to='spread_dashboard.SchLocation'),
        ),
    ]
